@inject IJSRuntime jsRuntime
@inject Observatory obz
@implements IDisposable

<div>
    @foreach(var toast in toasts){
        <div class="card fader" id="@toast.elID()"
            style="margin-top: 12px; background-color: @toast.GetBGCol(); opacity: @toast.GetOpacity();">
            <div class="toast-body" style="color: @toast.GetFGCol();">
                @if(toast.Data.Error){
                    <img src="/assets/icons/exclamation-octagon.svg" height="24" width="24">
                }else{
                    <img src="/assets/icons/info-circle.svg" height="24" width="24">
                }
                @toast.Data.Content
            </div>
        </div>
    }
</div>

@code {

    private List<Toast> toasts {get;set;} = new List<Toast>();
    private int toastCounter {get;set;} = 0;

    protected override void OnInitialized(){
        obz.Register<ToastData>("toast", onNewToast, "ToastMaster");
        obz.Register<ErrorMessage>("ERR", onServerError, "ToastMaster");
    }

    private void onServerError(ErrorMessage msg){
        onNewToast(new ToastData($"Error: {msg.data.info}", true));
    }

    private void onNewToast(ToastData t){
        var toast = new Toast(t, toastCounter++);
        toasts.Insert(0, toast);
        base.StateHasChanged();
        Task _ = fade(toast);
    }

    private async Task fade(Toast toast){
        await Task.Delay(100); // wait for the component to update and set opacity to 0.
        toast.Display = true;
        await jsRuntime.InvokeVoidAsync("blazorExtensions.ApplyStyle", toast.elID(), "opacity", 1);
        await Task.Delay(3000);
        toast.Display = false;
        await jsRuntime.InvokeVoidAsync("blazorExtensions.ApplyStyle", toast.elID(), "opacity", 0);
        toasts.Remove(toast);
    }

    public void Dispose(){
        obz.Deregister("ToastMaster");
    }

}